%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%  MDS Modular Design System  1.00 2007         
%  Th. Fetz, M. Mderl    
%  http://techmath.uibk.ac.at/fetz/downloads/mds.zip
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function J=junctions(MDS)

%
% J = junctions(MDS)
%
% returns the junctions of MDS
%
% J   njunctions x 7 matrix with columns
%
% id, elev, demand, set, type, x, y, z

mdstypes

ND = nodes(MDS);

I = find(bitand2(ND(:,4),JUNCTIONS));
index = ND(I,2);
J = [ND(I,1),MDS.junctions.elev(index), MDS.junctions.demand(index), ...
      ND(I,3:end)];

